﻿/*
 * FCKeditor - The text editor for Internet - http://www.fckeditor.net
 * Copyright (C) 2003-2007 Frederico Caldeira Knabben
 *
 * == BEGIN LICENSE ==
 *
 * Licensed under the terms of any of the following licenses at your
 * choice:
 *
 *  - GNU General Public License Version 2 or later (the "GPL")
 *    http://www.gnu.org/licenses/gpl.html
 *
 *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
 *    http://www.gnu.org/licenses/lgpl.html
 *
 *  - Mozilla Public License Version 1.1 or later (the "MPL")
 *    http://www.mozilla.org/MPL/MPL-1.1.html
 *
 * == END LICENSE ==
 *
 * FCKPastePlainTextCommand Class: represents the
 * "Paste as Plain Text" command.
 */

var FCKTableCommand = function( command )
{
	this.Name = command ;
}

FCKTableCommand.prototype.Execute = function()
{
	FCKUndo.SaveUndoStep() ;

	if ( FCKBrowserInfo.IsIE )
	{
		switch ( this.Name )
		{
			case 'TableMergeRight' : 
				return FCKTableHandler.MergeRight() ;
			case 'TableMergeDown' :
				return FCKTableHandler.MergeDown() ;
		}
	}

	switch ( this.Name )
	{
		case 'TableInsertRowAfter' :
			FCKTableHandler.InsertRow( false ) ;
			break ;
		case 'TableInsertRowBefore' :
			FCKTableHandler.InsertRow( true ) ;
			break ;
		case 'TableDeleteRows' :
			FCKTableHandler.DeleteRows() ;
			break ;
		case 'TableInsertColumnAfter' :
			FCKTableHandler.InsertColumn( false ) ;
			break ;
		case 'TableInsertColumnBefore' :
			FCKTableHandler.InsertColumn( true ) ;
			break ;
		case 'TableDeleteColumns' :
			FCKTableHandler.DeleteColumns() ;
			break ;
		case 'TableInsertCellAfter' :
			FCKTableHandler.InsertCell( null, false ) ;
			break ;
		case 'TableInsertCellBefore' :
			FCKTableHandler.InsertCell( null, true ) ;
			break ;
		case 'TableDeleteCells' :
			FCKTableHandler.DeleteCells() ;
			break ;
		case 'TableMergeCells' :
			FCKTableHandler.MergeCells() ;
			break ;
		case 'TableHorizontalSplitCell' :
			FCKTableHandler.HorizontalSplitCell() ;
			break ;
		case 'TableVerticalSplitCell' :
			FCKTableHandler.VerticalSplitCell() ;
			break ;
		case 'TableDelete' :
			FCKTableHandler.DeleteTable() ;
			break ;
		default :
			alert( FCKLang.UnknownCommand.replace( /%1/g, this.Name ) ) ;
	}
}

FCKTableCommand.prototype.GetState = function()
{
	if ( FCK.EditorDocument != null )
	{
		if( FCKSelection.HasAncestorNode( 'TABLE' ) ) 
			return FCK_TRISTATE_OFF ;
	}
	return FCK_TRISTATE_DISABLED; 
}
